--~  
--~ 	TRBot - bot for www.traviana.ru
--~ 	version 0.3
--~ 	programmed by Sarj (MaD) Sheff
--~  
 

local html = require("html")
local io = require("io")
local http = require("socket.http")
local ltn12 = require("ltn12")
local progcfg = require("progcfg")

http.PROXY = arg[3]

function getText(b,st)
	i = string.find(b,st,1,true) + #st
	str = string.sub(b,i)
	return string.sub(str,1,string.find(str,'"',1,true)-1),str
end



function login(p_username,p_password)

	b, c, h = http.request("http://s4.travian.ru/")
	--~ print(b) -- data
	--~ print(c) -- status
	--~ for k,v in pairs(h) do print(k,v) end -- headers

	login_url = "dorf1.php"
	p_login = getText(b,'<input type="hidden" name="login" value="')
	p_w = ""
	pn_username = getText(b,'<input class="fm fm110" type="text" name="')
	pn_password,last = getText(b,'<input class="fm fm110" type="password" name="')
	pn_p1,last = getText(last,'<input type="hidden" name="')
	p_p1,last = getText(last,' value="')
	p_s1 = "login"

	b, c, h = http.request("http://s4.travian.ru/"..login_url,"login="..p_login.."&w=&"..pn_username.."="..p_username.."&"..pn_password.."="..p_password.."&"..pn_p1.."="..p_p1.."&s1="..p_s1)


	return b,c,h
end

function getElementsByTagName(t,tagname)
	local tags = {}
	function wolker(tt)
		if tt then
		if tt._tag == tagname then
--~ 			for k,v in pairs(tt._attr) do print(k,v) end
			table.insert(tags,tt)
		end
		for i = 1,#tt do
			wolker(tt[i],tagname)
		end
		end
	end
	wolker(t)
	return tags
end

function dowork(url,cookie) 
	local ttt = {}
	local b,c,h = http.request{
		url = url,
		method = "GET",
		headers = { Cookie = cookie },
		sink = ltn12.sink.table(ttt)
	}
	return table.concat(ttt), h, c
end


function getProductionInfo(tbl)
	return tbl[2][4][1][1] , tbl[4][4][1][1]
end

function getReqInfo(tbl)
	local ret = {}
	local cost = 0
	for i = 2,12,2 do
	if i < 12 then
		local val = string.sub(tbl[1][1][i],1,string.find(tbl[1][1][i]," ",1,true)-1)	-- 0.2
		cost = cost + tonumber(val)							-- 0.2
		table.insert(ret,val)								-- 0.2
--~ 		print(string.sub(tbl[1][1][i],1,string.find(tbl[1][1][i]," ",1,true)-1))
	else
		table.insert(ret,tbl[1][1][i])
		
--~ 		print(tbl[1][1][i])
--~ 		print(string.sub(tbl[1][1][i],1,string.find(tbl[1][1][i],"<",1,true)-1))
	end
	end
	
	return ret,cost										-- 0.2
end

function getBuildings(areas,cookie)
local buildings = {}

for i = 1,#areas do
	if string.find(areas[i]._attr.href,"build.php",1,true) then
		local bb,hh,cc = dowork("http://s4.travian.ru/" .. areas[i]._attr.href,cookie)
		local ll = html.parsestr(bb)
		local building = {}
		building.title = areas[i]._attr.title
		building.href = areas[i]._attr.href
		local tables = getElementsByTagName(ll,"table")
--~ 		print("http://s4.travian.ru/" .. areas[i]._attr.href)
		building.production = getProductionInfo(tables[2])
		building.req,building.cost = getReqInfo(tables[3])
		local anchors = getElementsByTagName(ll,"a")
--~ 		print(#anchors)
		for i = 1,#anchors do
--~ 			print(anchors[i]._attr.href)
			if string.find(anchors[i]._attr.href,"a=",1,true) then			-- 0.2
				
				building.upgrade = anchors[i]._attr.href
--~ 				print(anchors[i]._attr.href)
			end
		end
		table.insert(buildings,building)
	end
end
return buildings
end

function matchtable(str,tbl)
	for i = 1,#tbl do
		if string.find(str,tostring(tbl[i]),1,true) then
			return true
		end
	end
	return false
end

function tostr(tbl)
	local ret = ""
	for i = 1,#tbl do 
		if type(tbl[i]) == "table" then
			ret = ret .. tostr(tbl[i])
		else
			local vvv = string.gsub(tbl[i], "(%s+)","")
			if #vvv > 1 then
				ret = ret .. " " .. tbl[i]
			end
		end
	end
	return ret
end

while true do
	print("login [" .. arg[1] .. "]...")
	local b,c,h = login(arg[1],arg[2])				-- 0.2
--~ 	print(b)
	local l = html.parsestr(b)
	local tables = getElementsByTagName(l,"table")
	print(tostr(tables[2]))
	print(tostr(tables[#tables]))
--~ 	print("Resource [ wood: " .. tables[2][2][5][1][1] .. " - " .. tables[#tables][1][4][1]
--~ 	" mood: " .. tables[2][4][5][1][1] .. " - " .. tables[#tables][1][8][1] .. 
--~ 	" iron: " .. tables[2][6][5][1][1] .. " - " .. tables[#tables][1][12][1] .. 
--~ 	" grain: " .. tables[2][8][5][1][1] .. " - " .. tables[#tables][1][15][1] .. "]")
--~  	for k,v in pairs(tables[2][2][4][1]) do print(k,v) end
	local areas = getElementsByTagName(l,"area")
	local upgraded = false  								-- 0.2
	
	print("fetching buildings data...")
	local blds = getBuildings(areas,h["set-cookie"])
	table.sort(blds, function(a,b) return a.cost < b.cost end )	-- 0.2
	for i = 1,#blds do
		if blds[i].upgrade then
			if not build_only or matchtable(blds[i].title,build_only) then
				if not not_build or not matchtable(blds[i].title,not_build) then
					print("upgrading " .. blds[i].title)
					dowork("http://s4.travian.ru/" .. blds[i].upgrade,h["set-cookie"])
					upgraded = true
					break
				end
			end
		end
	end
	
	if not upgraded then			
		print("nothing upgrade")	
	end					
	dowork("http://s4.travian.ru/logout.php",h["set-cookie"])  -- 0.2
	print("sleep " .. sleeptime .. " sec")
	os.execute("sleep " .. sleeptime)
end
--~ for k,v in pairs(h) do print(k,v) end -- headers
--~ b,c,h = dowork("http://s4.travian.ru/build.php?id=1",h["set-cookie"])
--~ b,c,h = dowork("http://s4.travian.ru/build.php?id=1",h["set-cookie"])
--~ print(b)
--~ http.request("http://s4.travian.ru/logout.php")